import React, { Component } from 'react'
import ProductCardGrid from "../../productPage/ProductCardGrid";



export default class Products extends Component {

    constructor(props) {
        super(props);
        this.state = {
            errorMessage: '',
            product: null

        }
        this.handleSubmit=this.handleSubmit.bind(this);
        this.changeActiveColor = this.changeActiveColor.bind(this);
        this.selectedColorClass = this.selectedColorClass.bind(this);
        this.selectedSizeClass = this.selectedSizeClass.bind(this);
        this.addToCart = this.addToCart.bind(this);
        // this.handleClick = this.handleClick.bind(this);
    }
    componentDidMount(){
        const self = this;
        setTimeout(function(){

            let product = self.props.product;
            product.active=false;
            product.sizes.map(function(size){
                size.active=false;
                // product.colors.map(function(color){
                //     color.active=false;
                // });
            });
            self.setState({product: product});
            console.log('products will mount',self.state.product);
        },100);
    }

    changeActiveSize(sizeIndex) {
        const self = this;
        let product = this.state.product;
        product.sizes.map((size)=>{
            size.active =false;
        });
        product.sizes[sizeIndex].active = true;

        this.setState({product: product});
    }

    changeActiveColor(sizeIndex, colorIndex) {
        let product = this.state.product;
        console.log(product);
        product.sizes.map((size)=>{
            if(size.active===true) {
                size.colors.map((color) => {
                    color.active = false;
                }); }
        });
        product.sizes[sizeIndex].colors[colorIndex].active = true;

        this.setState({product: product});
    }

    selectedColorClass(sizeIndex, colorIndex){
        const self = this;
        let returnValue = '';
        // console.log('funkcija',this.state.product.sizes[sizeIndex]);
        // if(this.state.product.sizes[sizeIndex].colors[colorIndex].active === true){
        //     return 'active';
        // }
        // else return '';
        if(self.state.product != null){
            if(self.state.product.sizes[sizeIndex].colors[colorIndex].active === true){
                returnValue = 'active';
            }
        }
        return returnValue;
    }

    selectedSizeClass(sizeIndex){
        const self = this;
        let returnValue = '';
        if(self.state.product != null){
            if(self.state.product.sizes[sizeIndex].active === true){
                returnValue = 'active';
            }
        }
        return returnValue;
    }

    addToCart(){
        const{title, price, sizes, description, status} = this.state;
        this.props.addProdToCart({
            title,
            price,
            sizes,
            description,
            status
        });
    }

    handleSubmit(){
        let valid = true;
        let product = this.state.product;
        for(let i = 0; i <product.sizes.length; i++) {
            if (product.sizes[i].active === true) {
                for (let k = 0; k < product.sizes[i].colors.length; k++) {
                    if (product.sizes[i].colors[k].active === true) {
                        this.setState({
                            ...this.state,
                            errorMessage: ""
                        });
                        valid=true;
                        break;
                    } else {
                        this.setState({
                            ...this.state,
                            errorMessage: "Please select color"
                        });
                        valid = false;
                    }
                }
                break;
            } else {
                this.setState({
                    ...this.state,
                    errorMessage: "Please select size"
                });
                valid = false;
            }
        }

        if(valid){
            const add = this.addToCart;
            add();
        }

    }




    render () {
        let products = this.props.products;
        let wishlistProds = this.props.wishlistProds;
        let addProdToCart = this.props.addProdToCart;



        return (
            <section className="product-area pt-75">
                <div className="container">
                    <div className="row justify-content-center">
                        <div className="col-lg-8">
                            <div className="section-title text-center pb-25">
                                <h4 className="title">Our Products</h4>
                                <p>Nam sem nisi, ultrices in sapien ac, posuere condimentum orci. Vestibulum.</p>
                            </div>
                        </div>
                    </div>
                    <div className="row">
                        {/*<div className="col-lg-4 col-sm-6">*!/*/}
                        {/*    <div className="single-product-2 mt-30">*/}

                        {products && products.slice(0, 6).map((product, index) => <div className=" d-flex col-lg-4 col-sm-8 single-product-3 mt-40 " ><ProductCardGrid product={product} key={product.id} addProdToCart={addProdToCart} wishlistProducts={wishlistProds} /> </div>)}



                        {/*{products.slice(0, 6).map(product =>*/}


                             {/*<div className="col-lg-4 col-sm-6">*/}
                             {/*    <div className="single-product-2 mt-30">*/}
                             {/*        <div className="product-image">*/}
                             {/*            <a href="#">*/}
                             {/*                <img className="product-1" src={photo1} alt="product"/>*/}
                             {/*                <img className="product-2" src={photo4} alt="product"/>*/}
                             {/*            </a>*/}
                             {/*        </div>*/}
                             {/*        <div className="product-content text-center">*/}
                             {/*            <ul className="product-rating">*/}
                             {/*                <li className="rating-on"><i className="flaticon-star"> </i></li>*/}
                             {/*                <li className="rating-on"><i className="flaticon-star"> </i></li>*/}
                             {/*                <li className="rating-on"><i className="flaticon-star"> </i></li>*/}
                             {/*                <li><i className="flaticon-star"> </i> </li>*/}
                             {/*                <li><i className="flaticon-star"> </i> </li>*/}
                             {/*            </ul>*/}
                             {/*            <h4 className="title" key={product.id}><a>{product.title} </a></h4>*/}
                             {/*            <span className="sale-price">${product.price}</span>*/}
                             {/*            <span className="regular-price">$299</span>*/}
                             {/*            <div className="product-size-color d-flex justify-content-between">*/}
                             {/*                <ul className="product-size">*/}
                             {/*                    {product.sizes.map((size, sizeIndex) =>*/}

                                               {/*<li onClick={() => { this.changeActiveSize(sizeIndex) }}*/}
                            {/*//                             className={this.selectedSizeClass(sizeIndex)} >*/}
                            {/*//                             <span>{size.size}</span>*/}
                            {/*//                         </li>*/}
                            {/*//                     )*/}
                            {/*//                     }*/}
                            {/*//                 </ul>*/}
                            {/*//                 <ul className="product-color">*/}
                            {/*//                     {product.sizes.map((size, sizeIndex) => size.active ? size.colors.map((color, colorIndex) =>*/}
                            {/*//                             <li style={{backgroundColor: color.color.toLowerCase()}} onClick={() => { this.changeActiveColor(sizeIndex, colorIndex) }}*/}
                            {/*//                                 className={this.selectedColorClass(sizeIndex, colorIndex)}>*/}
                            {/*//                                 <span>  </span>*/}
                            {/*//                             </li>*/}
                            {/*//                         ) : null*/}
                            {/*//                     )}*/}
                            {/*//                 </ul>*/}
                            {/*//             </div>*/}
                            {/*//             <span style={{color: "red"}} >{this.state.errorMessage}</span>*/}
                            {/*//             <div className="product-cart-btn">*/}
                            {/*//                 <a className="cart-btn" href="#"><i className="flaticon-shopping-cart"> </i>*/}
                            {/*//                     <span onClick={() => { this.handleSubmit() }}>Add to cart</span></a>*/}
                            {/*//             </div>*/}
                            {/*//         </div>*/}
                            {/*//     </div>*/}
                            {/*// </div>*/}






                        {/*// )}*/}



                    </div>
                    <div className="more-product text-center">
                        <a href="/list" className="more">View All Products</a>
                    </div>
                </div>
            </section>
        )
    }
}


